import 'package:osam_flutter/osam_flutter.dart';

mixin NavigationPresenter<US> on Presenter<US> {
  Navigation get navigation;

  void pop() => navigation.pop();

  void push(String route) => navigation.push(route);

  void pushReplacement(String route) => navigation.pushReplacement(route);

  void popUntil(String route) => navigation.popUntil(route);

  void pushAndRemoveUntil(String route) => navigation.pushAndRemoveUntil(route);

  List<String> get currentRoutes => navigation.routes.value;

  String get currentRoute => currentRoutes.last;

  String get firstRoute => currentRoutes.first;

  bool isInStack(String route) => currentRoutes.contains(route);

  bool get canPop => navigation.routes.value.length > 1;
}

mixin TabNavigationPresenter<US> on Presenter<US> {
  TabNavigation get tabNavigation;

  String get currentTab => tabNavigation.tabNotifier.value;

  void changeTab(String newTab) => tabNavigation.tab = newTab;
}
