import 'package:osam/osam.dart';

mixin Navigation {
  PropertyNotifier<List<String>> get routes;

  void push(String route) => routes.update((value) => value.add(route));

  void pop() => routes.update((value) => value.removeLast());

  void pushReplacement(String route) => routes.update((value) => value[value.length - 1] = route);

  void pushAndRemoveUntil(String route) => routes.update((value) {
        value.clear();
        value.add(route);
      });

  void popUntil(String route) => routes.update((value) {
        if (value.contains(route)) {
          while (value.last != route) {
            value.removeLast();
          }
        }
      });
}

mixin TabNavigation {
  PropertyNotifier<String> get tabNotifier;

  set tab(String tab) => tabNotifier.value = tab;
}
